/* Support of PKCS#7 data structures
 * Copyright (C) 2005 Christian Hoehn, Silvan Geeser
 * Copyright (C) 2002-2005 Andreas Steffen
 * Hochschule fuer Technik Rapperswil, Switzerland
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * RCSID $Id: pkcs7.h,v 1.4 2005/09/13 21:58:37 as Exp $
 */

#ifndef _PKCS7_H
#define _PKCS7_H

#include "defs.h"
#include "x509.h"

/* Access structure for a PKCS#7 ContentInfo object */

typedef struct contentInfo contentInfo_t;

struct contentInfo {
    int     type;
    chunk_t content;
};

extern bool parse_pkcs7_contentInfo(chunk_t blob, contentInfo_t *cInfo);
extern bool parse_pkcs7_cert(chunk_t blob, x509cert_t **cert);
extern chunk_t pkcs7_envelope_data(chunk_t data, const x509cert_t *cert
    , int cipher);

#endif /* _PKCS7_H */
